Merge "Minor fixes in yardstick fuel plugin"
[fuel.git] / build / install / install.sh
1 #!/bin/bash -e
2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
4 # stefan.k.berg@ericsson.com
5 # jonas.bjurel@ericsson.com
6 # All rights reserved. This program and the accompanying materials
7 # are made available under the terms of the Apache License, Version 2.0
8 # which accompanies this distribution, and is available at
9 # http://www.apache.org/licenses/LICENSE-2.0
10 ##############################################################################
11
12
13 my_exit() {
14     rc=$?
15
16     cd /tmp
17
18     if [ -n "$TMP_HOSTMOUNT" ]; then
19         if [ -d "$TMP_HOSTMOUNT" ]; then
20             fusermount -u $TMP_HOSTMOUNT
21             rmdir $TMP_HOSTMOUNT
22         fi
23     fi
24
25     if [ -d "$TMP_OLDISO" ]; then
26         fusermount -u $TMP_OLDISO
27         rmdir $TMP_OLDISO
28     fi
29
30     if [ -f "$CONF" ]; then
31         rm $CONF
32     fi
33
34     if [ -d "$TMP_ISOPUPPET" ]; then
35         rm -Rf $TMP_ISOPUPPET
36     fi
37 }
38
39 get_deb_name() {
40     ar p $1 control.tar.gz | tar xzO ./control | grep "^Package:.* " | sed 's/.* //'
41     if [ $PIPESTATUS -ne 0 ]; then
42         echo "Error in get_deb_name($1)"
43         exit 1
44     fi
45 }
46
47 get_deb_rev() {
48     ar p $1 control.tar.gz | tar xzO ./control | grep "^Version:.* " | sed 's/.* //'
49     if [ $PIPESTATUS -ne 0 ]; then
50         echo "Error in get_deb_rev($1)"
51         exit 1
52     fi
53 }
54
55
56 # Added logic for ".orig" files:
57 #   1. Is there an .orig file for the new file?
58 #   2. If the file is not present in base ISO -> Error!
59 #   3. If the file is changed i base ISO -> Error!  (need manual rebase)
60 #   4. If there is no .orig file, but file is present in base ISO: Error!
61 verify_orig_files() {
62     OLDDIR=$1
63     NEWDIR=$2
64
65     pushd $NEWDIR >/dev/null
66     for f in $(find * -type f -name '*.orig')
67     do
68         origfile=$NEWDIR/$f
69         oldfile=$OLDDIR/$(echo $f | sed 's/.orig$//')
70         newfile=$NEWDIR/$(echo $f | sed 's/.orig$//')
71
72         origfile=${newfile}.orig
73         # If no corresponding base file, error
74         if [ ! -f $oldfile ]; then
75             printf "\n\n\n\n"
76             echo "Error: found ${newfile} but no"
77             echo "Error: ${oldfile}"
78             echo "Error: Manual rebase is needed!"
79             printf "\n\n\n\n"
80             exit 1
81         fi
82
83         # If orig file differs from base file, error
84         if ! diff -q $origfile $oldfile > /dev/null; then
85             printf "\n\n\n\n"
86             echo "Error: $origfile differs from"
87             echo "Error: $oldfile!"
88             echo "Error: Manual rebase is needed!"
89             printf "\n\n\n\n"
90             exit 1
91         fi
92
93     done
94
95
96     # Check that there we're not overwriting oldfiles without having a ".orig" copy
97     for f in $(find * -type f ! -name '*.orig')
98     do
99         newfile=$NEWDIR/$(echo $f | sed 's/.orig$//')
100         origfile=${newfile}.orig
101         oldfile=$OLDDIR/$f
102         if [ -f $oldfile ]; then
103             if [ ! -f $origfile ]; then
104                 printf "\n\n\n\n"
105                 echo "Error: Will overwrite $oldfile, but there is no"
106                 echo "Error: $origfile!"
107                 echo "Error: You need to create the `basename $origfile`!"
108                 printf "\n\n\n\n"
109                 exit 1
110             fi
111         fi
112     done
113
114
115     popd >/dev/null
116 }
117
118 prep_make_live() {
119     DEST=$TMP_HOSTMOUNT
120     REPO=$DEST/var/www/nailgun/ubuntu/fuelweb/x86_64
121     echo "Live install"
122     ssh-copy-id root@$FUELHOST
123     sshfs root@1${FUELHOST}:/ $TMP_HOSTMOUNT
124
125     if [ -f  $REPO/dists/trusty/main/binary-amd64/Packages.backup ]; then
126         echo "Error - found backup file for Packages!"
127         exit 1
128     fi
129
130     if [ -f  $REPO/dists/trusty/main/binary-amd64/Packages.gz.backup ]; then
131         echo "Error - found backup file for Packages.gz!"
132         exit 1
133     fi
134
135     if [ -f  $REPO/dists/trusty/Release.backup ]; then
136         echo "Error - found backup file for Release!"
137         exit 1
138     fi
139
140     if [ -d  $DEST/etc/puppet.backup ]; then
141         echo "Error - found backup file for Puppet!"
142         exit 1
143     fi
144
145     cp $REPO/dists/trusty/main/binary-amd64/Packages $REPO/dists/trusty/main/binary-amd64/Packages.backup
146     cp $REPO/dists/trusty/main/binary-amd64/Packages.gz $REPO/dists/trusty/main/binary-amd64/Packages.gz.backup
147     cp $REPO/dists/trusty/Release $REPO/dists/trusty/Release.backup
148     cp -Rvp $DEST/etc/puppet $DEST/etc/puppet.backup
149 }
150
151 post_make_live() {
152     if [ -d $TOP/release/puppet/modules ]; then
153         echo "Installing into Puppet:"
154         cd $TOP/release/puppet/modules
155         if [ `ls -1 | wc -l` -gt 0 ]; then
156             for dir in *
157             do
158                 echo "   $dir"
159                 cp -Rp $dir $DEST/etc/puppet/modules
160             done
161         fi
162     fi
163 }
164
165 make_live() {
166     prep_make_live
167     copy_packages
168     post_make_live
169 }
170
171
172 prep_make_iso() {
173     DEST=$TOP/newiso
174     REPO=$DEST/ubuntu
175     echo "Preparing ISO..."
176     echo "Unpack of old ISO..."
177     if [ -d newiso ]; then
178         chmod -R 755 newiso
179         rm -rf newiso
180     fi
181     mkdir newiso
182     fusermount -u $TMP_OLDISO 2>/dev/null || cat /dev/null
183     fuseiso -p $ORIGISO $TMP_OLDISO
184     sleep 1
185     cd $TMP_OLDISO
186     find . | cpio -pd $TOP/newiso
187     cd ..
188     fusermount -u $TMP_OLDISO
189     rm -Rf $TMP_OLDISO
190     chmod -R 755 $TOP/newiso
191 }
192
193 make_iso_image() {
194     echo "Making ISO..."
195     cd $DEST
196     find . -name TRANS.TBL -exec rm {} \;
197     rm -rf rr_moved
198
199     mkisofs --quiet -r -V "$VOLUMEID" -publisher "$PUBLISHER" \
200         -p `git rev-parse --verify HEAD` -J -R -b isolinux/isolinux.bin \
201         -no-emul-boot \
202         -boot-load-size 4 -boot-info-table \
203         --hide-rr-moved \
204         --joliet-long \
205         -x "lost+found" -o $NEWISO .
206
207     isoinfo -d -i $NEWISO
208 }
209
210 # iso_copy_puppet: Create a new puppet-slave.tgz for the iso
211 iso_copy_puppet() {
212     echo "Installing into Puppet..."
213     mkdir -p $TMP_ISOPUPPET/release/puppet
214     cd $TMP_ISOPUPPET/release/puppet
215     tar xzf $DEST/puppet-slave.tgz
216     cd $TOP/release/puppet/modules
217
218     # Remove all .orig files before copying as they now have been verfied
219
220     if [ -d $TOP/release/puppet/modules ]; then
221         if [ `ls -1 | wc -l` -gt 0 ]; then
222             verify_orig_files $TMP_ISOPUPPET/release/puppet $TOP/release/puppet/modules
223             find $TOP/release/puppet/modules -type f -name '*.orig' -exec rm {} \;
224             for dir in $TOP/release/puppet/modules/*
225             do
226                 echo "   $dir"
227                 cp -Rp $dir $TMP_ISOPUPPET/release/puppet
228             done
229         fi
230     fi
231
232     cd $TMP_ISOPUPPET/release/puppet
233     tar czf $DEST/puppet-slave.tgz .
234     cd $TOP
235     rm -Rf $TMP_ISOPUPPET
236 }
237
238 # iso_modify_image: Add/patch files in the ISO root
239 iso_modify_image () {
240     # TODO: Add logic for ".orig" files (hey! make a function!), which would look
241     # something like:
242     #   1. Is there an .orig file?
243     #   2. If the file is not present in origiso -> Error exit
244     #   3. If the file is changed in origiso -> Error exit (need manual rebase)
245     #   4. Otherwise continue, but don't copy orig file (or maybe we should?)
246     # ... and corresponding reverse logic:
247     #   1. If there is no .orig file, but file is present in origiso -> Error exit
248     echo "Modify ISO files (wild copy)..."
249
250     verify_orig_files $DEST $TOP/release/isoroot
251     # Remove all .orig files before copying as they now have been verfied
252     find $TOP/release/isoroot -type f -name '*.orig' -exec rm {} \;
253
254     cd $TOP/release/isoroot
255     cp -Rvp . $DEST
256
257     # Add all Git info files
258     sort $TOP/gitinfo*.txt > $DEST/gitinfo.txt
259     cp $DEST/gitinfo.txt $REPORTFILE
260 }
261
262 make_iso() {
263     prep_make_iso
264     copy_packages
265     #iso_copy_puppet
266     iso_modify_image
267     make_iso_image
268 }
269
270 copy_packages() {
271     echo "Copying Debian packages..."
272     cd $TOP/release/packages/ubuntu/pool/debian-installer
273
274     for udeb in `ls -1 | grep '\.udeb$'`
275     do
276         echo "   $udeb"
277         cp $udeb $REPO/pool/debian-installer
278         echo "Did not expect a package here, not supported"
279         exit 1
280     done
281
282     cd $TOP/release/packages/ubuntu/pool/main
283     for deb in `ls -1 | grep '\.deb$'`
284     do
285         echo "   $deb"
286         cp $deb $REPO/pool/main
287         echo "Did not expect a package here, not supported"
288         exit 1
289     done
290
291     echo "Running Fuel package patch file"
292     pushd $REPO/pool/main > /dev/null
293
294     for line in `cat $TOP/apply_patches | grep -v "^#" | grep -v "^$"`; do
295         echo "Line is $line"
296         echo "Did not expect a line here, not supported"
297         exit 1
298         ref=`echo $line | cut -d '>' -f 1`
299         origpkg=`echo $line| cut -d '>' -f 2`
300         url=`echo $line | cut -d '>' -f 3`
301
302         if [ -z "$origpkg" ]; then
303             echo "Error: No origpkg for patching"
304             exit 1
305         fi
306
307         if [ -z "$url" ]; then
308             echo "Error: No url for patching"
309             exit 1
310         fi
311
312         if [ -z "$ref" ]; then
313             echo "Error: No reference text for patching"
314             exit 1
315         fi
316
317         echo "CM: Patching Fuel package for $ref" | tee -a $REPORTFILE
318         echo "CM: Replacing package $origpkg with $url" | tee -a $REPORTFILE
319         oldrev=`get_deb_rev $origpkg`
320         rm $origpkg
321         wget --quiet $url
322         topkg=`basename $url`
323         echo "CM: MD5 of new package:" | tee -a $REPORTFILE
324         md5sum $topkg | tee -a $REPORTFILE
325
326         patchname=`get_deb_name $topkg`
327         patchrev=`get_deb_rev $topkg`
328         echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
329         $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
330         if [ $PIPESTATUS -ne 0 ]; then
331             exit 1
332         fi
333     done
334
335     printf "Done running Fuel patch file\n\n"
336     echo "Running add packages file"
337     for line in `cat $TOP/add_opnfv_packages | grep -v "^#" | grep -v "^$"`; do
338         echo "Line is $line"
339         echo "Did not expect a line here, not supported"
340         exit 1
341         ref=`echo $line | cut -d '>' -f 1`
342         origpkg=`echo $line| cut -d '>' -f 2`
343         url=`echo $line | cut -d '>' -f 3`
344
345         if [ -z "$origpkg" ]; then
346             echo "Error: No origpkg for patching"
347             exit 1
348         fi
349
350         if [ -z "$url" ]; then
351             echo "Error: No url for patching"
352             exit 1
353         fi
354
355         if [ -z "$ref" ]; then
356             echo "Error: No reference text for patching"
357             exit 1
358         fi
359
360         if [ "$origpkg" != "NONE" ]; then
361             echo "CM: Patching added package for $ref" | tee -a $REPORTFILE
362             echo "CM: Replacing package $origpkg with $url" | tee -a $REPORTFILE
363             oldrev=`get_deb_rev $origpkg`
364             rm $origpkg
365         else
366             echo "CM: Adding previoulsy uninstalled package for $ref" tee -a $REPORTFILE
367         fi
368         wget --quiet $url
369         topkg=`basename $url`
370         echo "CM: MD5 of new package:" | tee -a $REPORTFILE
371         md5sum $topkg | tee -a $REPORTFILE
372         if [ "$origpkg" != "NONE" ]; then
373             patchname=`get_deb_name $topkg`
374             patchrev=`get_deb_rev $topkg`
375             echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
376             $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
377             if [ $PIPESTATUS -ne 0 ]; then
378                 exit 1
379             fi
380         fi
381     done
382     printf "Done running add packages file\n\n"
383
384     popd > /dev/null
385
386     if [ -f $TOP/patch-packages/release/patch-replacements ]; then
387         echo "Applying package patches" | tee -a $REPORTFILE
388         pushd $REPO/pool/main > /dev/null
389         printf "\n\n" | tee -a  $REPORTFILE
390         for line in `cat $TOP/patch-packages/release/patch-replacements`
391         do
392             echo "Did not expect a line here, not supported"
393             exit 1
394             frompkg=`echo $line | cut -d ">" -f 1`
395             topkg=`echo $line | cut -d ">" -f 2`
396             echo "CM: Applying patch to $frompkg" | tee -a $REPORTFILE
397             echo "CM: New package rev after patch: $topkg" | tee -a $REPORTFILE
398
399             if [ ! -f $frompkg ]; then
400                 echo "Error: Can't find $frompkg in repo"
401                 exit 1
402             else
403                 oldrev=`get_deb_rev $frompkg`
404                 echo "Removing $frompkg from repo"
405                 rm $frompkg
406             fi
407
408             if [ ! -f $TOP/patch-packages/release/packages/$topkg ]; then
409                 echo "Error: Can't find $topkg in patch release"
410                 exit 1
411             else
412                 echo "Adding $topkg to repo"
413                 cp $TOP/patch-packages/release/packages/$topkg .
414             fi
415
416             patchname=`get_deb_name $topkg`
417             patchrev=`get_deb_rev $topkg`
418             echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
419             $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
420             if [ $PIPESTATUS -ne 0 ]; then
421                 exit 1
422             fi
423         done
424         popd > /dev/null
425     fi
426
427     echo "Generating metadata..."
428     pushd $REPO > /dev/null
429
430     # The below methods are from 15B
431     APT_REL_CONF="$TOP/install/apt-ftparchive-release.conf"
432     APT_DEB_CONF="$TOP/install/apt-ftparchive-deb.conf"
433     APT_UDEB_CONF="$TOP/install/apt-ftparchive-udeb.conf"
434
435     echo Not running echo apt-ftparchive -c "${APT_REL_CONF}" generate "${APT_DEB_CONF}"
436     echo Not running apt-ftparchive -c "${APT_REL_CONF}" generate "${APT_DEB_CONF}"
437     echo Not running apt-ftparchive generate "${APT_UDEB_CONF}"
438     echo Not running apt-ftparchive generate "${APT_UDEB_CONF}"
439
440     # Fuel also needs this index file
441     # cat dists/trusty/main/binary-amd64/Packages | \
442     #    awk '/^Package:/{pkg=$2}
443     # /^Version:/{print pkg ": \"" $2 "\""}' > ubuntu-versions.yaml
444     # cp ubuntu-versions.yaml $DEST
445
446     # apt-ftparchive -c "${APT_REL_CONF}" release dists/trusty/ > dists/trusty/Release
447     # gzip -9cf dists/trusty/Release > dists/trusty/Release.gz
448
449     popd > /dev/null
450
451 }
452
453
454 #############################################################################
455
456 trap my_exit EXIT
457
458 CONF=`mktemp /tmp/XXXXXXX`
459 MODE=$1
460 TOP=`pwd`
461
462 if [ $MODE = "iso" ]; then
463     PUBLISHER="OPNFV"
464     TMP_OLDISO=`mktemp -d /tmp/XXXXXXX`
465     TMP_ISOPUPPET=`mktemp -d /tmp/XXXXXXX`
466     ORIGISO=$2
467     NEWISO=$3
468     VOLUMEID="$4_$5"
469     REPORTFILE="${NEWISO}.txt"
470     echo "Opening reportfile at $REPORTFILE"
471     touch $REPORTFILE
472     if [ ! -f $ORIGISO ]; then
473         echo "Can't find original iso at $ORIGISO"
474         rm $CONF
475         exit 1
476     fi
477
478     make_iso
479 else
480     echo "Unknown mode: $MODE"
481     exit 1
482 fi